@ECHO OFF
@ECHO **********************************************************************
@ECHO ** Script for Flash programming                                     **
@ECHO **********************************************************************
@ECHO ** Version 1.0                                                      **
@ECHO **********************************************************************
@ECHO .

rem # parameters:
rem #     %1: Path to SOF-File
rem #     %2: Path to ELF-File
rem #     %3: Base name of SOF-File
rem #     %4: Base name of ELF file
rem #     %5: device number
rem #     %6: base address of epcs

rem ECHO %1
rem ECHO %2
rem ECHO %3
rem ECHO %4
rem ECHO %5
rem ECHO %6

rem Download a NIOS processor configuration first
%QUARTUS_ROOTDIR%\bin\quartus_pgm --mode=jtag -o p;%1\%3.sof@%5

rem convert flash files
java -jar %SOPC_KIT_NIOS2%\bin\sof2flash.jar --epcs --quiet --input=%1\%3.sof --output=%3.flash
java -jar %SOPC_KIT_NIOS2%\bin\elf2flash.jar --quiet --base=0x00000000 --end=0x7fffff --reset=0x0 --input=%2\%4.elf --output=%4.flash --boot="%QUARTUS_ROOTDIR%/../ip/altera/nios2_ip/altera_nios2/boot_loader_cfi.srec"

rem # set path to cygwin1.dll
set PATH=%PATH%;%QUARTUS_ROOTDIR%\bin\cygwin\bin

rem Now flash the configuration
%SOPC_KIT_NIOS2%\bin\nios2-flash-programmer --epcs --device=%5 --program --verify --base=%6 %3.flash

rem Now flash the NIOS SW
%SOPC_KIT_NIOS2%\bin\nios2-flash-programmer --device=%5 --program --verify --base=0x00000000 %4.flash

rem delete temp. files
del %3.flash
del %4.flash
